Index: issm/trunk/src/m/classes/clusters/pfe.m
===================================================================
--- issm/trunk/src/m/classes/clusters/pfe.m	(revision 25994)
+++ issm/trunk/src/m/classes/clusters/pfe.m	(revision 26744)
@@ -1,3 +1,3 @@
-%PFE class definition
+%PFE cluster class definition
 %
 %   Usage:
@@ -7,9 +7,9 @@
 
 classdef pfe
-	properties (SetAccess=public)  
+	properties (SetAccess=public)
 		% {{{
 		name           = 'pfe'
 		login          = '';
-		modules        = {'comp-intel/2016.2.181' 'mpi-sgi/mpt'};
+		modules        = {'comp-intel/2016.2.181' 'mpt'};
 		numnodes       = 20;
 		cpuspernode    = 8;
@@ -21,5 +21,5 @@
 		codepath       = '';
 		executionpath  = '';
-		grouplist     = 's1690';
+		grouplist      = '';
 		interactive    = 0;
 		bbftp          = 0;
@@ -39,26 +39,27 @@
 		%}}}
 		function disp(cluster) % {{{
-			%  display the object
+			% display the object
 			disp(sprintf('class ''%s'' object ''%s'' = ',class(cluster),inputname(1)));
 			disp(sprintf('    name: %s',cluster.name));
 			disp(sprintf('    login: %s',cluster.login));
-			modules=''; for i=1:length(cluster.modules), modules=[modules cluster.modules{i} ',']; end; modules=modules(1:end-1); 
-			disp(sprintf('    modules: %s',modules));
+			disp(sprintf('    modules: %s',strjoin(cluster.modules,', ')));
+			disp(sprintf('    numnodes: %s',cluster.numnodes));
+			disp(sprintf('    cpuspernode: %s',cluster.cpuspernode));
+			disp(sprintf('    np: %i',cluster.nprocs()));
 			disp(sprintf('    port: %i',cluster.port));
-			disp(sprintf('    numnodes: %i',cluster.numnodes));
-			disp(sprintf('    cpuspernode: %i',cluster.cpuspernode));
-			disp(sprintf('    np: %i',cluster.cpuspernode*cluster.numnodes));
-			disp(sprintf('    queue: %s',cluster.queue));
+			disp(sprintf('    queue: %i',cluster.queue));
 			disp(sprintf('    time: %i',cluster.time));
-			disp(sprintf('    processor: %s',cluster.processor));
-			disp(sprintf('    srcpath: %s ($ISSM_DIR on pfe)',cluster.srcpath));
-			disp(sprintf('    codepath: %s  ($ISSM_DIR/bin on pfe)',cluster.codepath));
-			disp(sprintf('    executionpath: %s  (directory containing issm.exe on pfe)',cluster.executionpath));
+			disp(sprintf('    processor: %i',cluster.processor));
+			disp(sprintf('    srcpath: %s',cluster.srcpath));
+			disp(sprintf('    codepath: %s',cluster.codepath));
+			disp(sprintf('    executionpath: %s',cluster.executionpath));
 			disp(sprintf('    grouplist: %s',cluster.grouplist));
-			disp(sprintf('    interactive: %i',cluster.interactive));
-			disp(sprintf('    hyperthreading: %i',cluster.hyperthreading));
-		end
-		%}}}
-		function numprocs=np(cluster) % {{{
+			disp(sprintf('    interactive: %s',cluster.interactive));
+			disp(sprintf('    bbftp: %s',cluster.bbftp));
+			disp(sprintf('    numstreams: %s',cluster.numstreams));
+			disp(sprintf('    hyperthreading: %s',cluster.hyperthreading));
+		end
+		%}}}
+		function numprocs=nprocs(cluster) % {{{
 			%compute number of processors
 			numprocs=cluster.numnodes*cluster.cpuspernode;
@@ -71,5 +72,5 @@
 			queue_requirements_np=[2048 2048 150 150 2048];
 
-			QueueRequirements(available_queues,queue_requirements_time,queue_requirements_np,cluster.queue,cluster.np,cluster.time)
+			QueueRequirements(available_queues,queue_requirements_time,queue_requirements_np,cluster.queue,cluster.nprocs(),cluster.time)
 
 			%now, check cluster.cpuspernode according to processor type
@@ -128,5 +129,5 @@
 			
 			else
-				md = checkmessage(md,'unknown processor type, should be ''bro'' or ''has'' or ''ivy'' or ''san'' or ''cas_ait''');
+				md = checkmessage(md,'unknown processor type, should be ''bro'', ''has'', ''ivy'', ''san'', or ''cas_ait''');
 			end
 
@@ -161,9 +162,9 @@
 			fprintf(fid,'#PBS -l select=%i:ncpus=%i:model=%s\n',cluster.numnodes,cluster.cpuspernode,cluster.processor);
 			fprintf(fid,'#PBS -l walltime=%i\n',cluster.time*60); %walltime is in seconds.
-			fprintf(fid,'#PBS -q %s \n',cluster.queue);
+			fprintf(fid,'#PBS -q %s\n',cluster.queue);
 			fprintf(fid,'#PBS -W group_list=%s\n',cluster.grouplist);
 			fprintf(fid,'#PBS -m e\n');
-			fprintf(fid,'#PBS -o %s.outlog \n',[cluster.executionpath '/' dirname '/' modelname]);
-			fprintf(fid,'#PBS -e %s.errlog \n\n',[cluster.executionpath '/' dirname '/' modelname]);
+			fprintf(fid,'#PBS -o %s/%s/%s.outlog \n',cluster.executionpath,dirname,modelname);
+			fprintf(fid,'#PBS -e %s/%s/%s.errlog \n\n',cluster.executionpath,dirname,modelname);
 			fprintf(fid,'. /usr/share/modules/init/bash\n\n');
 			for i=1:numel(cluster.modules), fprintf(fid,['module load ' cluster.modules{i} '\n']); end
@@ -176,7 +177,7 @@
 			fprintf(fid,'cd %s/%s/\n\n',cluster.executionpath,dirname);
 			if ~isvalgrind,
-				fprintf(fid,'/u/scicon/tools/bin/several_tries mpiexec -np %i /u/scicon/tools/bin/mbind.x -cs -n%i %s/%s %s %s %s\n',cluster.np,cluster.cpuspernode,cluster.codepath,executable,solution,[cluster.executionpath '/' dirname],modelname);
-			else
-				fprintf(fid,'mpiexec -np %i valgrind --leak-check=full %s/%s %s %s %s\n',cluster.np,cluster.codepath,executable,solution,[cluster.executionpath '/' dirname],modelname);
+				fprintf(fid,'/u/scicon/tools/bin/toss3/several_tries mpiexec -np %i %s/%s %s %s/%s %s\n',cluster.nprocs(),cluster.codepath,executable,solution,cluster.executionpath,dirname,modelname);
+			else
+				fprintf(fid,'mpiexec -np %i valgrind --leak-check=full %s/%s %s %s %s\n',cluster.nprocs(),cluster.codepath,executable,solution,[cluster.executionpath '/' dirname],modelname);
 			end
 			if ~io_gather, %concatenate the output files:
@@ -190,10 +191,10 @@
 				if cluster.interactive==10,
 						fprintf(fid,'module unload mpi-mvapich2/1.4.1/gcc\n');
-						fprintf(fid,'mpiexec -np %i %s/%s %s %s %s\n',cluster.np,cluster.codepath,executable,solution,[pwd() '/run'],modelname);
+						fprintf(fid,'mpiexec -np %i %s/%s %s %s %s\n',cluster.nprocs(),cluster.codepath,executable,solution,[pwd() '/run'],modelname);
 				else
 					if ~isvalgrind,
-						fprintf(fid,'mpiexec -np %i %s/%s %s %s %s\n',cluster.np,cluster.codepath,executable,solution,[cluster.executionpath '/Interactive' num2str(cluster.interactive)],modelname);
+						fprintf(fid,'mpiexec -np %i %s/%s %s %s %s\n',cluster.nprocs(),cluster.codepath,executable,solution,[cluster.executionpath '/Interactive' num2str(cluster.interactive)],modelname);
 					else
-						fprintf(fid,'mpiexec -np %i valgrind --leak-check=full %s/%s %s %s %s\n',cluster.np,cluster.codepath,executable,solution,[cluster.executionpath '/Interactive' num2str(cluster.interactive)],modelname);
+						fprintf(fid,'mpiexec -np %i valgrind --leak-check=full %s/%s %s %s %s\n',cluster.nprocs(),cluster.codepath,executable,solution,[cluster.executionpath '/Interactive' num2str(cluster.interactive)],modelname);
 					end
 				end
@@ -214,7 +215,7 @@
 
 			%what is the executable being called? 
-			executable='issm_slr.exe';
-
-			if ispc(), error('BuildQueueScriptMultipleModels not support yet on windows machines');end;
+			executable='issm_slc.exe';
+
+			if ispc & ~ismingw, error('BuildQueueScriptMultipleModels not support yet on windows machines');end;
 
 			%write queuing script 
@@ -318,5 +319,5 @@
 			fprintf(fid,'export MPI_GROUP_MAX=64\n\n');
 			fprintf(fid,'cd %s/%s/\n\n',cluster.executionpath,modelname);
-			fprintf(fid,'mpiexec -np %i %s/kriging.exe %s %s\n',cluster.np,cluster.codepath,[cluster.executionpath '/' modelname],modelname); %FIXME
+			fprintf(fid,'mpiexec -np %i %s/kriging.exe %s %s\n',cluster.nprocs(),cluster.codepath,[cluster.executionpath '/' modelname],modelname); %FIXME
 			if ~io_gather, %concatenate the output files:
 				fprintf(fid,'cat %s.outbin.* > %s.outbin',modelname,modelname);
@@ -328,7 +329,7 @@
 				fid=fopen([modelname '.run'],'w');
 				if ~isvalgrind,
-					fprintf(fid,'mpiexec -np %i %s/kriging.exe %s %s\n',cluster.np,cluster.codepath,[cluster.executionpath '/' modelname],modelname);
-				else
-					fprintf(fid,'mpiexec -np %i valgrind --leak-check=full %s/kriging.exe %s %s\n',cluster.np,cluster.codepath,[cluster.executionpath '/' modelname],modelname);
+					fprintf(fid,'mpiexec -np %i %s/kriging.exe %s %s\n',cluster.nprocs(),cluster.codepath,[cluster.executionpath '/' modelname],modelname);
+				else
+					fprintf(fid,'mpiexec -np %i valgrind --leak-check=full %s/kriging.exe %s %s\n',cluster.nprocs(),cluster.codepath,[cluster.executionpath '/' modelname],modelname);
 				end
 				if ~io_gather, %concatenate the output files:
@@ -382,8 +383,8 @@
 
 		end %}}}
-		function UploadQueueJob(cluster,modelname,dirname,filelist)% {{{
+		function UploadQueueJob(cluster,modelname,dirname,filelist) % {{{
 
 			%compress the files into one zip.
-			compressstring=['tar -zcf ' dirname '.tar.gz '];
+			compressstring=['tar -zcf ' dirname '.tar.gz'];
 			for i=1:numel(filelist),
 				compressstring = [compressstring ' ' filelist{i}];
@@ -403,23 +404,16 @@
 			end
 
-			if ~cluster.bbftp,
+			if cluster.bbftp,
+				issmbbftpout(cluster.name,directory,cluster.login,cluster.port,cluster.numstreams,{[dirname '.tar.gz']});
+			else
 				issmscpout(cluster.name,directory,cluster.login,cluster.port,{[dirname '.tar.gz']});
-			else
-				issmbbftpout(cluster.name,directory,cluster.login,cluster.port,cluster.numstreams,{[dirname '.tar.gz']});
-			end
-
-		end
-		%}}}
-		function LaunchQueueJob(cluster,modelname,dirname,filelist,restart,batch)% {{{
-
-			%lauch command, to be executed via ssh
-			if ~cluster.interactive, 
-				if ~isempty(restart)
-					launchcommand=['cd ' cluster.executionpath ' && cd ' dirname ' && qsub ' modelname '.queue '];
-				else
-					launchcommand=['cd ' cluster.executionpath ' && rm -rf ./' dirname ' && mkdir ' dirname ...
-						' && cd ' dirname ' && mv ../' dirname '.tar.gz ./ && tar -zxf ' dirname '.tar.gz  && qsub ' modelname '.queue '];
-				end
-			else
+			end
+
+		end
+		%}}}
+		function LaunchQueueJob(cluster,modelname,dirname,filelist,restart,batch) % {{{
+
+			%launch command, to be executed via ssh
+			if cluster.interactive,
 				if ~isempty(restart)
 					launchcommand=['cd ' cluster.executionpath '/Interactive' num2str(cluster.interactive)];
@@ -431,4 +425,11 @@
 					end
 				end
+			else
+				if ~isempty(restart)
+					launchcommand=['cd ' cluster.executionpath ' && cd ' dirname ' && qsub ' modelname '.queue '];
+				else
+					launchcommand=['cd ' cluster.executionpath ' && rm -rf ./' dirname ' && mkdir ' dirname ...
+						' && cd ' dirname ' && mv ../' dirname '.tar.gz ./ && tar -zxf ' dirname '.tar.gz && qsub ' modelname '.queue '];
+				end
 			end
 
@@ -437,5 +438,5 @@
 		end
 		%}}}
-		function Download(cluster,dirname,filelist)% {{{
+		function Download(cluster,dirname,filelist) % {{{
 
 			%copy files from cluster to current directory
@@ -448,8 +449,8 @@
 			end
 
-			if ~cluster.bbftp,
+			if cluster.bbftp,
+				issmbbftpin(cluster.name, cluster.login, cluster.port, cluster.numstreams, directory, filelist);
+			else
 				issmscpin(cluster.name,cluster.login,cluster.port,directory,filelist);
-			else
-				issmbbftpin(cluster.name, cluster.login, cluster.port, cluster.numstreams, directory, filelist);
 			end
 
Index: issm/trunk/src/m/classes/clusters/pfe.py
===================================================================
--- issm/trunk/src/m/classes/clusters/pfe.py	(revision 25994)
+++ issm/trunk/src/m/classes/clusters/pfe.py	(revision 26744)
@@ -1,29 +1,32 @@
 import subprocess
+
 from fielddisplay import fielddisplay
-from pairoptions import pairoptions
-from issmssh import issmssh
+from helpers import *
+from IssmConfig import IssmConfig
 from issmscpin import issmscpin
 from issmscpout import issmscpout
-from QueueRequirements import QueueRequirements
-from IssmConfig import IssmConfig
+from issmssh import issmssh
+from MatlabFuncs import *
+from pairoptions import pairoptions
 try:
     from pfe_settings import pfe_settings
 except ImportError:
-    print('You need pfe_settings.py to proceed, check presence and sys.path')
-
+    # print('You need pfe_settings.py to proceed, check presence and sys.path')
+    pass
+from QueueRequirements import QueueRequirements
 
 class pfe(object):
+    """PFE cluster class definition
+
+    Usage:
+        cluster = pfe()
+        cluster = pfe('np', 3)
+        cluster = pfe('np', 3, 'login', 'username')
     """
-    PFE cluster class definition
-
-       Usage:
-          cluster = pfe()
-          cluster = pfe('np', 3)
-          cluster = pfe('np', 3, 'login', 'username')
-    """
-
-    def __init__(self, *args):    # {{{
-        self.name = 'pfe'
+
+    def __init__(self, *args):  # {{{
+        self.name = ''
         self.login = ''
+        self.modules = ['comp-intel/2016.2.181', 'mpt']
         self.numnodes = 20
         self.cpuspernode = 8
@@ -31,9 +34,9 @@
         self.queue = 'long'
         self.time = 12 * 60
-        self.processor = 'bro'
+        self.processor = 'ivy'
         self.srcpath = ''
         self.codepath = ''
         self.executionpath = ''
-        self.grouplist = 's1010'
+        self.grouplist = ''
         self.interactive = 0
         self.bbftp = 0
@@ -41,44 +44,47 @@
         self.hyperthreading = 0
 
-        #use provided options to change fields
+        # Use provided options to change fields
         options = pairoptions(*args)
 
-        #initialize cluster using user settings if provided
-        self = pfe_settings(self)
-        self.np = self.nprocs()
-
-        #OK get other fields
+        # Initialize cluster using user settings if provided
+        try:
+            self = pfe_settings(self)
+        except NameError:
+            #print('pfe_settings.py not found, using default settings')
+            pass
+
+        # OK get other fields
         self = options.AssignObjectFields(self)
-
-    # }}}
-
-    def __repr__(self):    # {{{
-        #  display the object
-        s = "class pfe object:"
-        s = "%s\n%s" % (s, fielddisplay(self, 'name', 'name of the cluster'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'login', 'login'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'numnodes', 'number of nodes'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'cpuspernode', 'number of nodes per CPUs'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'np', 'number of CPUs'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'port', 'machine access port'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'queue', 'name of the queue'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'time', 'walltime requested'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'processor', 'type of processor'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'codepath', '$ISSM_DIR on pfe'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'executionpath', 'directory containing issm.exe on pfe'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'grouplist', 'name of the group'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'interactive', ''))
-        s = "%s\n%s" % (s, fielddisplay(self, 'bbftp', ''))
-        s = "%s\n%s" % (s, fielddisplay(self, 'numstreams', ''))
-        s = "%s\n%s" % (s, fielddisplay(self, 'hyperthreading', ''))
+    # }}}
+
+    def __repr__(self):  # {{{
+        # Display the object
+        s = 'class pfe object\n'
+        s += '    name: {}\n'.format(self.name)
+        s += '    login: {}\n'.format(self.login)
+        s += '    modules: {}\n'.format(strjoin(self.modules, ', '))
+        s += '    numnodes: {}\n'.format(self.numnodes)
+        s += '    cpuspernode: {}\n'.format(self.cpuspernode)
+        s += '    np: {}\n'.format(self.nprocs())
+        s += '    port: {}\n'.format(self.port)
+        s += '    queue: {}\n'.format(self.queue)
+        s += '    time: {}\n'.format(self.time)
+        s += '    processor: {}\n'.format(self.processor)
+        s += '    srcpath: {}\n'.format(self.srcpath)
+        s += '    codepath: {}\n'.format(self.codepath)
+        s += '    executionpath: {}\n'.format(self.executionpath)
+        s += '    grouplist: {}\n'.format(self.grouplist)
+        s += '    interactive: {}\n'.format(self.interactive)
+        s += '    bbftp: {}\n'.format(self.bbftp)
+        s += '    numstreams: {}\n'.format(self.numstreams)
+        s += '    hyperthreading: {}\n'.format(self.hyperthreading)
         return s
     # }}}
 
-    def nprocs(self):    # {{{
-        self.np = self.numnodes * self.cpuspernode
-        return self.np
-    # }}}
-
-    def checkconsistency(self, md, solution, analyses):    # {{{
+    def nprocs(self):  # {{{
+        return self.numnodes * self.cpuspernode
+    # }}}
+
+    def checkconsistency(self, md, solution, analyses):  # {{{
         queuedict = {'long': [5 * 24 * 60, 2048],
                      'normal': [8 * 60, 2048],
@@ -87,32 +93,44 @@
         QueueRequirements(queuedict, self.queue, self.nprocs(), self.time)
 
-        #now, check cluster.cpuspernode according to processor type
-        if self.processor == 'har' or self.processor == 'neh':
-            if self.hyperthreading:
-                if not 0 < self.cpuspernode < 17:
-                    md = md.checkmessage('cpuspernode should be between 1 and 16 for ''neh'' and ''har'' processors in hyperthreading mode')
-            else:
-                if not 0 < self.cpuspernode < 9:
-                    md = md.checkmessage('cpuspernode should be between 1 and 8 for ''neh'' and ''har'' processors')
-
+        # Now, check cluster.cpuspernode according to processor type
+        if self.processor == 'ivy':
+            if self.hyperthreading:
+                if self.cpuspernode > 40 or self.cpuspernode < 1:
+                    md = md.checkmessage('cpuspernode should be between 1 and 40 for \'ivy\' processors in hyperthreading mode')
+            else:
+                if self.cpuspernode > 20 or self.cpuspernode < 1:
+                    md = md.checkmessage('cpuspernode should be between 1 and 20 for \'ivy\' processors')
         elif self.processor == 'bro':
             if self.hyperthreading:
-                if not 0 < self.cpuspernode < 57:
-                    md = md.checkmessage('cpuspernode should be between 1 and 56 for ''bro'' processors in hyperthreading mode')
-            else:
-                if not 0 < self.cpuspernode < 29:
-                    md = md.checkmessage('cpuspernode should be between 1 and 28 for ''bro'' processors')
-
-        elif self.processor == 'ivy':
-            if self.hyperthreading:
-                if not 0 < self.cpuspernode < 41:
-                    md = md.checkmessage('cpuspernode should be between 1 and 40 for ''ivy'' processors in hyperthreading mode')
-            else:
-                if not 0 < self.cpuspernode < 21:
-                    md = md.checkmessage('cpuspernode should be between 1 and 20 for ''ivy'' processors')
+                if self.cpuspernode > 56 or self.cpuspernode < 1:
+                    md = md.checkmessage('cpuspernode should be between 1 and 56 for \'bro\' processors in hyperthreading mode')
+            else:
+                if self.cpuspernode > 28 or self.cpuspernode < 1:
+                    md = md.checkmessage('cpuspernode should be between 1 and 28 for \'bro\' processors')
+        elif self.processor == 'has':
+            if self.hyperthreading:
+                if self.cpuspernode > 48 or self.cpuspernode < 1:
+                    md = md.checkmessage('cpuspernode should be between 1 and 48 for \'has\' processors in hyperthreading mode')
+            else:
+                if self.cpuspernode > 24 or self.cpuspernode < 1:
+                    md = md.checkmessage('cpuspernode should be between 1 and 24 for \'has\' processors')
+        elif self.processor == 'san':
+            if self.hyperthreading:
+                if self.cpuspernode > 32 or self.cpuspernode < 1:
+                    md = md.checkmessage('cpuspernode should be between 1 and 32 for \'san\' processors in hyperthreading mode')
+            else:
+                if self.cpuspernode > 16 or self.cpuspernode < 1:
+                    md = md.checkmessage('cpuspernode should be between 1 and 16 for \'san\' processors')
+        elif self.processor == 'cas_ait':
+            if self.hyperthreading:
+                if self.cpuspernode > 80 or self.cpuspernode < 1:
+                    md = md.checkmessage('cpuspernode should be between 1 and 80 for \'cas_ait\' processors in hyperthreading mode')
+            else:
+                if self.cpuspernode > 40 or self.cpuspernode < 1:
+                    md = md.checkmessage('cpuspernode should be between 1 and 40 for \'cas_ait\' processors')
         else:
-            md = md.checkmessage('unknown processor type, should be ''neh'', ''bro'' or ''har'' or ''ivy''')
-
-        #Miscellaneous
+            md = md.checkmessage('unknown processor type, should be \'bro\', \'has\', \'ivy\', \'san\', or \'cas_ait\'')
+
+        # Miscellaneous
         if not self.login:
             md = md.checkmessage('login empty')
@@ -125,11 +143,12 @@
         if not self.grouplist:
             md = md.checkmessage('grouplist empty')
-        if self.interactive == 1:
-            md = md.checkmessage('interactive mode not implemented')
 
         return self
     # }}}
 
-    def BuildQueueScript(self, dirname, modelname, solution, io_gather, isvalgrind, isgprof, isdakota, isoceancoupling):    # {{{
+    def BuildQueueScript(self, dirname, modelname, solution, io_gather, isvalgrind, isgprof, isdakota, isoceancoupling):  # {{{
+        if isgprof:
+            print('gprof not supported by cluster, ignoring...')
+
         executable = 'issm.exe'
         if isdakota:
@@ -141,52 +160,64 @@
             executable = 'issm_ocean.exe'
 
-    #write queuing script
+        # Write queuing script
         fid = open(modelname + '.queue', 'w')
-        fid.write('#PBS -S / bin / bash\n')
-        fid.write('#PBS -l select=%i:ncpus=%i:model=%s\n' % (self.numnodes, self.cpuspernode, self.processor))
-        fid.write('#PBS -l walltime=%i\n' % (self.time * 60))
-        fid.write('#PBS -q %s \n' % self.queue)
-        fid.write('#PBS -W group_list=%s\n' % self.grouplist)
+        fid.write('#PBS -S /bin/bash\n')
+        fid.write('#PBS -l select={}:ncpus={}:model={}\n'.format(self.numnodes, self.cpuspernode, self.processor))
+        fid.write('#PBS -l walltime={}\n'.format(self.time * 60)) # walltime is in seconds
+        fid.write('#PBS -q {} \n'.format(self.queue))
+        fid.write('#PBS -W group_list={}\n'.format(self.grouplist))
         fid.write('#PBS -m e\n')
-        fid.write('#PBS -o %s/%s/%s.outlog \n' % (self.executionpath, dirname, modelname))
-        fid.write('#PBS -e %s/%s/%s.errlog \n\n' % (self.executionpath, dirname, modelname))
-        fid.write('./usr/share/modules/init/bash\n\n')
-        fid.write('module load comp-intel/2015.0.090\n')
-        fid.write('module load mpi-sgi/mpt.2.11r13\n')
+        fid.write('#PBS -o {}/{}/{}.outlog \n'.format(self.executionpath, dirname, modelname))
+        fid.write('#PBS -e {}/{}/{}.errlog \n\n'.format(self.executionpath, dirname, modelname))
+        fid.write('. /usr/share/modules/init/bash\n\n')
+        for i in range(len(self.modules)):
+            fid.write('module load {}\n'.format(self.modules[i]))
         fid.write('export PATH="$PATH:."\n\n')
+        fid.write('export MPI_LAUNCH_TIMEOUT=520\n')
         fid.write('export MPI_GROUP_MAX=64\n\n')
-        fid.write('export ISSM_DIR="%s"\n' % self.srcpath)
-        fid.write('source $ISSM_DIR/etc/environment.sh\n')
+        fid.write('export ISSM_DIR="{}"\n'.format(self.srcpath)) # FIXME
+        fid.write('source $ISSM_DIR/etc/environment.sh\n') # FIXME
         fid.write('export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$ISSM_DIR/externalpackages/petsc/install/lib"\n')
-        fid.write('cd %s/%s/ \n\n' % (self.executionpath, dirname))
-        fid.write('mpiexec - np %i %s/%s %s %s/%s %s\n' % (self.nprocs(), self.codepath, executable, str(solution), self.executionpath, dirname, modelname))
+        fid.write('cd {}/{}/\n\n'.format(self.executionpath, dirname))
+        fid.write('mpiexec -np {} {}/{} {} {}/{} {}\n'.format(self.nprocs(), self.codepath, executable, solution, self.executionpath, dirname, modelname))
 
         fid.close()
-
-    # }}}
-
-    def UploadQueueJob(self, modelname, dirname, filelist):    # {{{
-        #compress the files into one zip.
-        compressstring = 'tar -zcf %s.tar.gz ' % dirname
+    # }}}
+
+    def UploadQueueJob(self, modelname, dirname, filelist):  # {{{
+        # Compress the files into one zip
+        compressstring = 'tar -zcf {}.tar.gz'.format(dirname)
         for file in filelist:
-            compressstring += ' %s' % file
+            compressstring += ' {}'.format(file)
         subprocess.call(compressstring, shell=True)
 
         print('uploading input file and queueing script')
-        issmscpout(self.name, self.executionpath, self.login, self.port, [dirname + '.tar.gz'])
-
-    # }}}
-    def LaunchQueueJob(self, modelname, dirname, filelist, restart, batch):    # {{{
+        directory = self.executionpath
+        issmscpout(self.name, directory, self.login, self.port, [dirname + '.tar.gz'])
+
+    # }}}
+    def LaunchQueueJob(self, modelname, dirname, filelist, restart, batch):  # {{{
+        # Launch command, to be executed via ssh
+        if self.interactive:
+            if not isempty(restart):
+                launchcommand = 'cd {} /Interactive{}'.format(self.executionpath, self.interactive)
+            else:
+                if self.interactive == 10:
+                    launchcommand = 'cd {}/run && tar -zxf {}.tar.gz'.format(pwd(), dirname)
+                else:
+                    launchcommand = 'cd {} /Interactive{} && tar -zxf {}.tar.gz'.format(self.executionpath, self.interactive, dirname)
+        else:
+            if not isempty(restart):
+                launchcommand = 'cd {} && cd {} && qsub {}.queue'.format(self.executionpath, dirname, modelname)
+            else:
+                launchcommand = 'cd {} && rm -rf ./{} && mkdir {} && cd {} && mv ../{}.tar.gz ./ && tar -zxf {}.tar.gz  && qsub {}.queue'.format(self.executionpath, dirname, dirname, dirname, dirname, dirname, modelname)
+
         print('launching solution sequence on remote cluster')
-        if restart:
-            launchcommand = 'cd %s && cd %s && qsub %s.queue' % (self.executionpath, dirname, modelname)
-        else:
-            launchcommand = 'cd %s && rm -rf ./%s && mkdir %s && cd %s && mv ../%s.tar.gz ./ && tar -zxf %s.tar.gz  && qsub %s.queue' % (self.executionpath, dirname, dirname, dirname, dirname, dirname, modelname)
         issmssh(self.name, self.login, self.port, launchcommand)
 
     # }}}
-    def Download(self, dirname, filelist):    # {{{
-        #copy files from cluster to current directory
-        directory = '%s/%s/' % (self.executionpath, dirname)
+    def Download(self, dirname, filelist):  # {{{
+        # Copy files from cluster to current directory
+        directory = '{}/{}/'.format(self.executionpath, dirname)
         issmscpin(self.name, self.login, self.port, directory, filelist)
     # }}}
